package org.jboss.qa.brno.quiz;

import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToMany;
import javax.persistence.NamedQuery;

@Entity
@NamedQuery(name = "findAuthorByName", query = "select a from Author a where a.firstName = :firstName and a.lastName = :lastName")
public class Author {
	@Id @GeneratedValue(strategy = GenerationType.AUTO)
	private int id;

	@Column
	private String firstName;
	
	@Column
	private String lastName;

	@ManyToMany(mappedBy = "authors")
	private Set<Book> books;

	public Author() {	
	}
	
	public Author(String firstName, String lastName) {
		super();
		this.firstName = firstName;
		this.lastName = lastName;
	}
	public String getFirstName() {
		return firstName;
	}
	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}
	public String getLastName() {
		return lastName;
	}
	public void setLastName(String lastName) {
		this.lastName = lastName;
	}
	
	public String getFullName() {
		return lastName + " " + firstName;
	}
	
	public Set<Book> getBooks() {
		return books;
	}

	public int getId() {
		return id;
	}
}
