package org.jboss.qa.brno.quiz;

import java.util.HashSet;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.NamedQuery;

@Entity
@NamedQuery(name = "findAllBooks", query = "select b from Book b")
public class Book {
	
	public Book() {
	}

	@Id
	private String isbn;
	
	@Column
	private String title;
	
	@ManyToMany(targetEntity = Author.class)
	@JoinTable(name = "books_authors")
	private Set<Author> authors;
	
	public Book(String isbn, String title, Author author) {
		super();
		this.isbn = isbn;
		this.title = title;
		authors = new HashSet<Author>();
		authors.add(author);
	}
	
	public Book(String isbn, String title, Author author1, Author author2) {
		super();
		this.isbn = isbn;
		this.title = title;
		authors = new HashSet<Author>();
		authors.add(author1);
		authors.add(author2);
	}
	
	public String getTitle() {
		return title;
	}
	public void setTitle(String title) {
		this.title = title;
	}
	public String getIsbn() {
		return isbn;
	}
	public void setIsbn(String isbn) {
		this.isbn = isbn;
	}
	public Set<Author> getAuthors() {
		return authors;
	}

	public void setAuthors(Set<Author> authors) {
		this.authors = authors;
	}	
}
