package org.jboss.qa.brno.quiz;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

public class Library 
{
	EntityManager em;
	private static EntityManagerFactory entityManagerFactory;
	
	public synchronized static EntityManager getEntityManager() {
		if (entityManagerFactory == null) {
			entityManagerFactory = Persistence.createEntityManagerFactory("jbossquiz");
		}
		return entityManagerFactory.createEntityManager();
	}
	
	public Library() {
		em = getEntityManager(); 
	}

	
	public void addBook(Book book) {
		em.getTransaction().begin();
		Set<Author> authors = new HashSet<Author>(); 
		for (Author author: book.getAuthors()) {
			List<Author> queryResult = em.createNamedQuery("findAuthorByName", Author.class).setParameter("firstName", author.getFirstName()).setParameter("lastName", author.getLastName()).getResultList();
			if (queryResult.size() == 1) {
				authors.add(queryResult.get(0));
			}
			else {
				em.persist(author);
				authors.add(author);
			}
		}
		book.setAuthors(authors);
		em.persist(book);
		em.flush();
		em.getTransaction().commit();
	}
}
