package org.jboss.qa.brno.quiz;

import java.util.Iterator;
import java.util.List;

import javax.persistence.EntityManager;

public class Report 
{
	EntityManager em;
	
	public Report() {
		em = Library.getEntityManager();
	}

	public void generateBookReport() {
		final String format = "%10s %32s %32s%n";
		System.out.printf(format, "ISBN", "Title", "Author");
		System.out.println("============================================================================================================");

		em.getTransaction().begin();
		List<Book> books = em.createNamedQuery("findAllBooks", Book.class).getResultList();
		for (Book b: books) {
			StringBuilder authors = new StringBuilder();
			for (Iterator<Author> iterator = b.getAuthors().iterator(); iterator.hasNext();) {
				authors.append(iterator.next().getFullName());
				if (iterator.hasNext()) {
					authors.append(", ");
				}
			}
			System.out.printf(format, b.getIsbn(), b.getTitle(), authors.toString());
		}
		em.getTransaction().commit();
	}
}
